// {{{RME classifier 'Logical View::Planejamento'

#if defined( PRAGMA ) && ! defined( PRAGMA_IMPLEMENTED )
#pragma implementation "Planejamento.h"
#endif

#include <RTSystem/SolicitarPacotesComponent.h>
#include <Planejamento.h>

// {{{RME classifier 'Logical View::Planejamento' tool 'OT::Cpp' property 'ImplementationPreface'
// {{{USR tool 'OT::Cpp' property 'ImplementationPreface'
// }}}USR
// }}}RME

static const RTRelayDescriptor rtg_relays[] =
{
	{
		"operador_comm"
	  , &CommSolicitaPacote::Conjugate::rt_class
	  , 1 // cardinality
	}
};

static RTActor * new_Planejamento_Actor( RTController * _rts, RTActorRef * _ref )
{
	return new Planejamento_Actor( _rts, _ref );
}

const RTActorClass Planejamento =
{
	(const RTActorClass *)0
  , "Planejamento"
  , (RTVersionId)0
  , 1
  , rtg_relays
  , new_Planejamento_Actor
};

static const char * const rtg_state_names[] =
{
	"TOP"
};

#define SUPER RTActor

Planejamento_Actor::Planejamento_Actor( RTController * rtg_rts, RTActorRef * rtg_ref )
	: RTActor( rtg_rts, rtg_ref )
{
}

Planejamento_Actor::~Planejamento_Actor( void )
{
}

// {{{RME classifier 'Logical View::Planejamento' operation 'Enfileira_pct()'
void Planejamento_Actor::Enfileira_pct( void )
{
	// {{{USR operation 'Enfileira_pct()'
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::Planejamento' operation 'Elimina_pct()'
void Planejamento_Actor::Elimina_pct( void )
{
	// {{{USR operation 'Elimina_pct()'
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::Planejamento' operation 'Verifica_status_pva()'
void Planejamento_Actor::Verifica_status_pva( void )
{
	// {{{USR operation 'Verifica_status_pva()'
	// }}}USR
}
// }}}RME

// {{{RME classifier 'Logical View::Planejamento' operation 'Verifica_fila_vazia()'
void Planejamento_Actor::Verifica_fila_vazia( void )
{
	// {{{USR operation 'Verifica_fila_vazia()'
	// }}}USR
}
// }}}RME

int Planejamento_Actor::_followInV( RTBindingEnd & rtg_end, int rtg_portId, int rtg_repIndex )
{
	switch( rtg_portId )
	{
	case 0:
		// operador_comm
		if( rtg_repIndex < 1 )
		{
			rtg_end.port = &operador_comm;
			rtg_end.index = rtg_repIndex;
			return 1;
		}
		break;
	default:
		break;
	}
	return RTActor::_followInV( rtg_end, rtg_portId, rtg_repIndex );
}

void Planejamento_Actor::rtsBehavior( int signalIndex, int portIndex )
{
	for( int stateIndex = getCurrentState(); ; stateIndex = rtg_parent_state[ stateIndex - 1 ] )
		switch( stateIndex )
		{
		case 1:
			// {{{RME classifier 'Logical View::Planejamento' state ':TOP'
			switch( portIndex )
			{
			case 0:
				switch( signalIndex )
				{
				case 1:
					return;
				default:
					break;
				}
				break;
			default:
				break;
			}
			unexpectedMessage();
			return;
			// }}}RME
		default:
			unexpectedState();
			return;
		}
}

const RTActor_class * Planejamento_Actor::getActorData( void ) const
{
	return &Planejamento_Actor::rtg_class;
}

const RTActor_class Planejamento_Actor::rtg_class =
{
	(const RTActor_class *)0
  , rtg_state_names
  , 1
  , Planejamento_Actor::rtg_parent_state
  , &Planejamento
  , 0
  , (const RTComponentDescriptor *)0
  , 1
  , Planejamento_Actor::rtg_ports
  , 0
  , (const RTLocalBindingDescriptor *)0
  , 3
  , Planejamento_Actor::rtg_Planejamento_fields
};

const RTStateId Planejamento_Actor::rtg_parent_state[] =
{
	0
};

const RTPortDescriptor Planejamento_Actor::rtg_ports[] =
{
	{
		"operador_comm"
	  , (const char *)0
	  , &CommSolicitaPacote::Conjugate::rt_class
	  , RTOffsetOf( Planejamento_Actor, Planejamento_Actor::operador_comm )
	  , 1 // cardinality
	  , 1
	  , RTPortDescriptor::End
	  , RTPortDescriptor::NotificationDisabled
	  , RTPortDescriptor::RegisterNotPermitted
	  , RTPortDescriptor::PublicVisibility
	  , RTPortDescriptor::Wired
	}
};

const RTFieldDescriptor Planejamento_Actor::rtg_Planejamento_fields[] =
{
	// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Missao'
	{
		"Missao"
	  , RTOffsetOf( Planejamento_Actor, Missao )
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Missao' tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_int
		// }}}RME
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Missao' tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Status_pva'
  , {
		"Status_pva"
	  , RTOffsetOf( Planejamento_Actor, Status_pva )
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Status_pva' tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_bool
		// }}}RME
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'Status_pva' tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
	// {{{RME classifier 'Logical View::Planejamento' classAttribute 'PctID'
  , {
		"PctID"
	  , RTOffsetOf( Planejamento_Actor, PctID )
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'PctID' tool 'OT::CppTargetRTS' property 'TypeDescriptor'
	  , &RTType_long
		// }}}RME
		// {{{RME classifier 'Logical View::Planejamento' classAttribute 'PctID' tool 'OT::CppTargetRTS' property 'GenerateTypeModifier'
	  , (const RTTypeModifier *)0
		// }}}RME
	}
	// }}}RME
};
#undef SUPER

// {{{RME classifier 'Logical View::Planejamento' tool 'OT::Cpp' property 'ImplementationEnding'
// {{{USR tool 'OT::Cpp' property 'ImplementationEnding'
// }}}USR
// }}}RME

// }}}RME
